package lookupraceconditiontestclient;

import com.sun.appserv.security.ProgrammaticLogin;
import javax.naming.Context;
import javax.naming.InitialContext;
import lookupraceconditiontest.TestRemote;

public class Main {

    public static final int num = 100;

    public static void main(String[] args) throws Exception {

        System.setProperty("java.security.auth.login.config", "./config/login.conf");

        System.setProperty("com.sun.appserv.iiop.endpoints", "localhost:3700");
        System.setProperty("com.sun.appserv.iiop.loadbalancingpolicy", "ic-based");

        System.out.println("create login context");
        try {
            ProgrammaticLogin programmaticLogin = new ProgrammaticLogin();
            programmaticLogin.login("user1", "pwd1");
        } catch (Exception e) {
            e.printStackTrace();
        }

        Thread[] thread = new Thread[num];

        for (int i = 0; i < num; i++) {

            thread[i] = new SayHelloThread();
            thread[i].setName("SayHelloThread[" + i + "]");
            thread[i].start();

        }

        for (int i = 0; i < num; i++) {
            thread[i].join();
        }

        System.out.println("done");

    }

    static class SayHelloThread extends Thread {

        @Override
        public void run() {
            System.out.println(Thread.currentThread().getName() + " - started");

            try {
                Context ctx = new InitialContext();
                TestRemote testRemote = (TestRemote) ctx.lookup("lookupraceconditiontest.TestRemote");
                System.out.println(Thread.currentThread().getName() + " - call returned: " + testRemote.sayHello(Thread.currentThread().getName()));
            } catch (Exception e) {
                System.err.println(Thread.currentThread().getName() + " - call threw exception: " + e.getMessage());
                e.printStackTrace();
            }

            System.out.println(Thread.currentThread().getName() + " - ended");
        }
    }

}
